<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CGenerator.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">CGenerator.java</span></div><h1>CGenerator.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

import java.util.ArrayList;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;

/**
 * C++ Code generator front-end for Hadoop record I/O.
 */
class CGenerator {
    private String mName;
    private ArrayList&lt;JFile&gt; mInclFiles;
    private ArrayList&lt;JRecord&gt; mRecList;
    private final File outputDirectory;

    /** Creates a new instance of CppGenerator
     *
     * @param name possibly full pathname to the file
     * @param ilist included files (as JFile)
     * @param rlist List of records defined within this file
     * @param outputDirectory
     */
    CGenerator(String name, ArrayList&lt;JFile&gt; ilist, ArrayList&lt;JRecord&gt; rlist,
            File outputDirectory)
<span class="nc" id="L45">    {</span>
<span class="nc" id="L46">        this.outputDirectory = outputDirectory;</span>
<span class="nc" id="L47">        mName = (new File(name)).getName();</span>
<span class="nc" id="L48">        mInclFiles = ilist;</span>
<span class="nc" id="L49">        mRecList = rlist;</span>
<span class="nc" id="L50">    }</span>

    /**
     * Generate C++ code. This method only creates the requested file(s)
     * and spits-out file-level elements (such as include statements etc.)
     * record-level code is generated by JRecord.
     */
    void genCode() throws IOException {
<span class="nc bnc" id="L58" title="All 2 branches missed.">        if (!outputDirectory.exists()) {</span>
<span class="nc bnc" id="L59" title="All 2 branches missed.">            if (!outputDirectory.mkdirs()) {</span>
<span class="nc" id="L60">                throw new IOException(&quot;unable to create output directory &quot;</span>
                        + outputDirectory);
            }
        }
<span class="nc" id="L64">        FileWriter c = new FileWriter(new File(outputDirectory, mName+&quot;.c&quot;));</span>
<span class="nc" id="L65">        FileWriter h = new FileWriter(new File(outputDirectory, mName+&quot;.h&quot;));</span>

<span class="nc" id="L67">        h.write(&quot;/**\n&quot;);</span>
<span class="nc" id="L68">        h.write(&quot;* Licensed to the Apache Software Foundation (ASF) under one\n&quot;);</span>
<span class="nc" id="L69">        h.write(&quot;* or more contributor license agreements.  See the NOTICE file\n&quot;);</span>
<span class="nc" id="L70">        h.write(&quot;* distributed with this work for additional information\n&quot;);</span>
<span class="nc" id="L71">        h.write(&quot;* regarding copyright ownership.  The ASF licenses this file\n&quot;);</span>
<span class="nc" id="L72">        h.write(&quot;* to you under the Apache License, Version 2.0 (the\n&quot;);</span>
<span class="nc" id="L73">        h.write(&quot;* \&quot;License\&quot;); you may not use this file except in compliance\n&quot;);</span>
<span class="nc" id="L74">        h.write(&quot;* with the License.  You may obtain a copy of the License at\n&quot;);</span>
<span class="nc" id="L75">        h.write(&quot;*\n&quot;);</span>
<span class="nc" id="L76">        h.write(&quot;*     http://www.apache.org/licenses/LICENSE-2.0\n&quot;);</span>
<span class="nc" id="L77">        h.write(&quot;*\n&quot;);</span>
<span class="nc" id="L78">        h.write(&quot;* Unless required by applicable law or agreed to in writing, software\n&quot;);</span>
<span class="nc" id="L79">        h.write(&quot;* distributed under the License is distributed on an \&quot;AS IS\&quot; BASIS,\n&quot;);</span>
<span class="nc" id="L80">        h.write(&quot;* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n&quot;);</span>
<span class="nc" id="L81">        h.write(&quot;* See the License for the specific language governing permissions and\n&quot;);</span>
<span class="nc" id="L82">        h.write(&quot;* limitations under the License.\n&quot;);</span>
<span class="nc" id="L83">        h.write(&quot;*/\n&quot;);</span>
<span class="nc" id="L84">        h.write(&quot;\n&quot;);</span>

<span class="nc" id="L86">        c.write(&quot;/**\n&quot;);</span>
<span class="nc" id="L87">        c.write(&quot;* Licensed to the Apache Software Foundation (ASF) under one\n&quot;);</span>
<span class="nc" id="L88">        c.write(&quot;* or more contributor license agreements.  See the NOTICE file\n&quot;);</span>
<span class="nc" id="L89">        c.write(&quot;* distributed with this work for additional information\n&quot;);</span>
<span class="nc" id="L90">        c.write(&quot;* regarding copyright ownership.  The ASF licenses this file\n&quot;);</span>
<span class="nc" id="L91">        c.write(&quot;* to you under the Apache License, Version 2.0 (the\n&quot;);</span>
<span class="nc" id="L92">        c.write(&quot;* \&quot;License\&quot;); you may not use this file except in compliance\n&quot;);</span>
<span class="nc" id="L93">        c.write(&quot;* with the License.  You may obtain a copy of the License at\n&quot;);</span>
<span class="nc" id="L94">        c.write(&quot;*\n&quot;);</span>
<span class="nc" id="L95">        c.write(&quot;*     http://www.apache.org/licenses/LICENSE-2.0\n&quot;);</span>
<span class="nc" id="L96">        c.write(&quot;*\n&quot;);</span>
<span class="nc" id="L97">        c.write(&quot;* Unless required by applicable law or agreed to in writing, software\n&quot;);</span>
<span class="nc" id="L98">        c.write(&quot;* distributed under the License is distributed on an \&quot;AS IS\&quot; BASIS,\n&quot;);</span>
<span class="nc" id="L99">        c.write(&quot;* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n&quot;);</span>
<span class="nc" id="L100">        c.write(&quot;* See the License for the specific language governing permissions and\n&quot;);</span>
<span class="nc" id="L101">        c.write(&quot;* limitations under the License.\n&quot;);</span>
<span class="nc" id="L102">        c.write(&quot;*/\n&quot;);</span>
<span class="nc" id="L103">        c.write(&quot;\n&quot;);</span>

<span class="nc" id="L105">        h.write(&quot;#ifndef __&quot;+mName.toUpperCase().replace('.','_')+&quot;__\n&quot;);</span>
<span class="nc" id="L106">        h.write(&quot;#define __&quot;+mName.toUpperCase().replace('.','_')+&quot;__\n&quot;);</span>

<span class="nc" id="L108">        h.write(&quot;#include \&quot;recordio.h\&quot;\n&quot;);</span>
<span class="nc bnc" id="L109" title="All 2 branches missed.">        for (Iterator&lt;JFile&gt; i = mInclFiles.iterator(); i.hasNext();) {</span>
<span class="nc" id="L110">            JFile f = i.next();</span>
<span class="nc" id="L111">            h.write(&quot;#include \&quot;&quot;+f.getName()+&quot;.h\&quot;\n&quot;);</span>
<span class="nc" id="L112">        }</span>
        // required for compilation from C++
<span class="nc" id="L114">        h.write(&quot;\n#ifdef __cplusplus\nextern \&quot;C\&quot; {\n#endif\n\n&quot;);</span>

<span class="nc" id="L116">        c.write(&quot;#include &lt;stdlib.h&gt;\n&quot;); // need it for calloc() &amp; free()</span>
<span class="nc" id="L117">        c.write(&quot;#include \&quot;&quot;+mName+&quot;.h\&quot;\n\n&quot;);</span>

<span class="nc bnc" id="L119" title="All 2 branches missed.">        for (Iterator&lt;JRecord&gt; i = mRecList.iterator(); i.hasNext();) {</span>
<span class="nc" id="L120">            JRecord jr = i.next();</span>
<span class="nc" id="L121">            jr.genCCode(h, c);</span>
<span class="nc" id="L122">        }</span>

<span class="nc" id="L124">        h.write(&quot;\n#ifdef __cplusplus\n}\n#endif\n\n&quot;);</span>
<span class="nc" id="L125">        h.write(&quot;#endif //&quot;+mName.toUpperCase().replace('.','_')+&quot;__\n&quot;);</span>

<span class="nc" id="L127">        h.close();</span>
<span class="nc" id="L128">        c.close();</span>
<span class="nc" id="L129">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>